<?php
	// easyPages: script for displaying contents in folders in a web page quickly.
	// Author: Jeremy A. Snyder, 27-Aug-2007
	
	// CHANGE NOTES: 
	// Updated (JAS): 22-Jan-2008
	//	* sorting of directories and filenames before the list is displayed
	//	* removal of Thumbs.db (windows hidden file)
	//	* configurable page title via the $pagetitle variable
	//	* general cleanup and re-ordering of configuration vs code
	// Update (JAS): 24-Jan-2008
	//      * reset arrays d[] and d2[] on each iteration thru script, and removed unnecessary valid and invalid arrays
	// Update (JAS): 14-Mar-2008
	//      * Added file icons for MSProject, Winzip and Unknown file types
	// 	* display "(Updated DD-MMM-YYYY HH:MM) after files
	//	* display "new" icon if the file was updated in last 14days
	// Update (JAS): 4-Feb-2009
	//      * Correct string manipulation to get Name and Extension
	//      * Add Frame icon

	//** CONFIGURATION SECTION **
	// $pagetitle = provides the ability to define the "title" of the document in the browser and user bookmarks
	// if it is an empty string, it will show a generic title that includes the easyPages version number.
	$pagetitle = "";
	$displayUpdate = true;
?>



<?php
	$easyPagesVersion = "v0.22";
	// Currently, this is used to determine the directory the script contained in
	// ... could be manually configured to save the calculation of it on each execution.
	// to manually configure... comment out these lines, and
	$pathArr = explode('/', $_SERVER["SCRIPT_FILENAME"]);
	array_pop($pathArr);
	$startPath = implode("/", $pathArr);
	$startPath .= "/";
	// uncomment and modify this line:
	// $pathArr = "/s2/u2/jsnyder/internal_html/easyPages/";

?>

<html>
<head>
<title><? if ($pagetitle) { echo $pagetitle; } else { echo "easyPages " . $easyPagesVersion; } ?></title>
<style type="text/css">
h1 img {
	margin-right: 5px;
}
.folderList li {
	list-style: none;
}
.folderList li img {
	margin-right: 5px;
	vertical-align: middle;
}
</style>
</head>
<body>
<?php
$d = Array();
$dh = opendir($startPath);
while (false !== ($filename = readdir($dh))) {
  $d[] = $filename;
}
closedir($dh);
natcasesort($d);  // Natural Order Sort (case insensitive sort & numbers in their natual order 1, 2, 3, 11, 12...)

// echo "Path: " . $d->path . "\n";
foreach($d as $entry) {
   if ((is_dir($entry)) && (substr($entry,0,1) != '.') && ($entry != 'resources')) {
		$pathvar = $startPath . $entry;
		echo "<h1><img src='resources/images/Folder.png' />".$entry."</h1>\n";
		$chk = 0;		
		echo "<ul class='folderList'>";
		$d2 = Array();
		$dh2 = opendir($pathvar);
		while (false !== ($filename = readdir($dh2))) {
		  $d2[] = $filename;
		}
		closedir($dh2);
		natcasesort($d2);  // Natural Order Sort (case insensitive sort & numbers in their natual order 1, 2, 3, 11, 12...)
		foreach($d2 as $e2) {
			// echo "<p>".$e2."</p>\n";
			if ((substr($e2,0,1) != '.') && ($e2 != 'Thumbs.db')) {
				$ext = strrchr($e2, '.');
                                $name = substr($e2, 0, strlen($e2)-strlen(strrchr($e2, '.')));
				switch(strtolower($ext)) {
					case '.txt':
						$image = "Text.png";
						break;
					case '.jpg':
					case '.gif':
					case '.png':
						$image = "Image.png";
						break;
					case '.fm':
                                                $image = "Frame.png";
                                                break;
					case '.pdf':
						$image = "Pdf.png";
						break;
					case '.doc':
						$image = "Word.png";
						break;
					case '.xls':
						$image = "Excel.png";
						break;
					case '.ppt':
						$image = "Powerpoint.png";
						break;
					case '.mdb':
						$image = "Access.png";
						break;
					case '.mpx':
						$image = "MSProject.png";
						break;
					case '.htm':
						$image = "Internet.png";
						break;
					case '.zip':
						$image = "WinZip.png";
						break;
					default:
						$image = "Unknown.png";
				}
				echo "<li><img src='resources/images/".$image."' /><a href='".$entry."/".$e2."'>".$name."</a><i>".displayUpdateText($folder.$entry."/".$e2)."</i></li>\n";
			}
		}
		echo "</ul>";
   }
}

	function displayUpdateText($file) {
		global $displayUpdate;
		$txt = "";
		if ($displayUpdate) {
			$txt = " (updated ".date("d-M-Y H:i", filemtime($file)).")".isNew($file);
		} 
		return $txt;
	}
	
	function isNew($file) {
		$txt = "";
		if (filemtime($file) > (time()- (60*60*24*14))) {
			$txt = "<img src='resources/images/New.gif' />";
		} else {
			$txt = "";
		}
		return $txt;
	}

?>
<p>&nbsp;</p>
<p>&nbsp;</p>
</body>
</html>
